#define	B	0100000
struct tab
{
	int	input;
	int	lexval;
	int	retval;
} tab[]
{
/*
 * one of a kind
 */

	'(',	unk,lpar,
	')',	unk,rpar,
	'[',	unk,lbkt,
	']',	unk,rbkt,
	'/',	COM,com,
	'-/'+B,	COM0,com0,
	'\'',	unk,strng,
	'K',	unk,strng,
	'J',	unk,null,
	'%',	unk,null,
	'.',	IPROD,dot,
	'L',	QUAD,quad,
	'KL'+B,	QQUAD,quad,
	'\'L'+B,QQUAD,quad,
	';',	unk,semi,
	':',	unk,cln,
	'CJ'+B,	COMNT,comnt,
	'C',	COMNT,comnt,
	'}',	BRAN0,tran,
	'->'+B,	BRAN0,tran,
	'=:',	BRAN0,tran,

/*
 * dyadic scalars
 *	op2 op1 v (dyadic op)
 */

	'<',	LT,dscal,
	'>',	GT,dscal,
	'<='+B,	LE,dscal,
	'<=',	LE,dscal,
	'$',	LE,dscal,
	'=>'+B,	GE,dscal,
	'>=',	GE,dscal,
	'&',	GE,dscal,
	'=',	EQ,dscal,
	'=|'+B,	NE,dscal,
	'/='+B,	NE,dscal,
	'=\\'+B,NE,dscal,
	'F',	NE,dscal,
	'!=',	NE,dscal,
	'A',	AND,dscal,
	'^',	AND,dscal,
	'V',	OR,dscal,
	'Q',	OR,dscal,
	'A~'+B,	NAND,dscal,
	'^~'+B,	NAND,dscal,
	'V~'+B,	NOR,dscal,
	'Q~'+B,	NOR,dscal,

/*
 * monadic or dyadic scalars
 *	op2 op1 v (dyadic op)
 *	op1 v+1 (monadic op)
 */

	'+',	ADD,mdscal,
	'-',	SUB,mdscal,
	'M',	MUL,mdscal,
	'P',	DIV,mdscal,
	'-:'+B,	DIV,mdscal,
	'|',	MOD,mdscal,
	'D',	MIN,mdscal,
	'S',	MAX,mdscal,
	'*',	PWR,mdscal,
	'*O'+B,	LOG,mdscal,
	'O',	CIR,mdscal,
	'!',	COMB,mdscal,
	'.K'+B,	COMB,mdscal,
	'\'.'+B,COMB,mdscal,

/*
 * monadic
 *	op1 v (monadic op)
 */

	'~',	NOT,m,

/*
 * dyadic
 *	op2 op1 v (dyadic op)
 */

	'E',	EPS,d,
	'B',	BASE,d,
	'N',	REP,d,
	'Y',	TAKE,d,
	'U',	DROP,d,
	'-\\'+B,EXD0,d,
	'{',	ASGN,asg,
	'-<'+B,	ASGN,asg,
	':=',	ASGN,asg,

/*
 * monadic or dyadic
 *	op2 op1 v (dyadic op)
 *	op1 v+1 (monadic op)
 */

	'?',	DEAL,md,
	'R',	DRHO,md,
	'I',	DIOT,md,
	'-O'+B,	ROT0,md,
	'O\\'+B,DTRN,md,
	'BN'+B,	DIBM,md,
	'IB'+B,	DIBM,md,
	'LP'+B,	DDOM,md,
	':/'+B,	DDOM,md,

/*
 * monadic with optional subscript
 *	op1 v (monadic op)
 *	op1 sub v+1 (subscripted monadic op)
 */

	'A|'+B,	GDU,msub,
	'H|'+B,	GDU,msub,
	'GU'+B,	GDU,msub,
	'V|'+B,	GDD,msub,
	'G|'+B,	GDD,msub,
	'GD'+B,	GDD,msub,

/*
 * dyadic with optional subscript
 *	op2 op1 v (dyadic op)
 *	op2 op1 sub v+1 (subscripted dyadic op)
 */

	'\\',	EXD,dsub,

/*
 * monadic or dyadic with optional subscript
 *	op2 op1 v (dyadic op)
 *	op1 v+1 (monadic op)
 *	op2 op1 sub v+2 (subscripted dyadic op)
 *	op1 sub v+3 (subscripted monadic op)
 */

	'O|'+B,	ROT,mdsub,
	',',	CAT,mdsub,

/*
 * end of list
 */

	0
};

int	comtab[]
{
	"clear",	comnam,		CLEAR,
	"debug",	comnull,	DEBUG,
	"digits",	comexpr,	DIGITS,
	"edit",		comnam,		EDIT,
	"erase",	comnam,		ERASE,
	"fns",		comnull,	FNS,
	"fuzz",		comexpr,	FUZZ,
	"load",		comnam,		LOAD,
	"origin",	comexpr,	ORIGIN,
	"vars",		comnam,		VARS,
	"width",	comexpr,	WIDTH,
	0,		unk
};
