#define	B	0100000
struct tab
{
	int	input;
	int	lexval;
	int	retval;
} tab[]
{
/*
 * one of a kind
 */

	':',	unk,lpar,
	'"',	unk,rpar,
	';',	unk,lbkt,
	'\'',	unk,rbkt,
	'/',	COM,com,
	'_/'+B,	COM0,com0,
	'K',	unk,strng,
	'J',	unk,null,
	'.',	IPROD,dot,
	'L',	QUAD,quad,
	'KL'+B,	QQUAD,quad,
	'<',	unk,semi,
	'>',	unk,cln,
	'CJ'+B,	COMNT,comnt,
	']',	BRAN0,tran,

/*
 * dyadic scalars
 *	op2 op1 v (dyadic op)
 */

	'#',	LT,dscal,
	'>',	GT,dscal,
	'$',	LE,dscal,
	'^',	GE,dscal,
	'%',	EQ,dscal,
	'*',	NE,dscal,
	')',	AND,dscal,
	'(',	OR,dscal,
	')$'+B,	NAND,dscal,
	'($'+B,	NOR,dscal,

/*
 * monadic or dyadic scalars
 *	op2 op1 v (dyadic op)
 *	op1 v+1 (monadic op)
 */

	'-',	ADD,mdscal,
	'_',	SUB,mdscal,
	'=',	MUL,mdscal,
	'+',	DIV,mdscal,
	'M',	MOD,mdscal,
	'D',	MIN,mdscal,
	'S',	MAX,mdscal,
	'P',	PWR,mdscal,
	'PO'+B,	LOG,mdscal,
	'O',	CIR,mdscal,
	'.K'+B,	COMB,mdscal,

/*
 * monadic
 *	op1 v (monadic op)
 */

	'$',	NOT,m,

/*
 * dyadic
 *	op2 op1 v (dyadic op)
 */

	'E',	EPS,d,
	'B',	BASE,d,
	'N',	REP,d,
	'Y',	TAKE,d,
	'U',	DROP,d,
	'-?'+B,EXD0,d,
	'[',	ASGN,asg,

/*
 * monadic or dyadic
 *	op2 op1 v (dyadic op)
 *	op1 v+1 (monadic op)
 */

	'Q',	DEAL,md,
	'R',	DRHO,md,
	'I',	DIOT,md,
	'_O'+B,	ROT0,md,
	'O?'+B,DTRN,md,
	'BN'+B,	DIBM,md,
	'L+'+B,	DDOM,md,

/*
 * monadic with optional subscript
 *	op1 v (monadic op)
 *	op1 sub v+1 (subscripted monadic op)
 */

	'HM'+B,	GDU,msub,
	'GM'+B,	GDD,msub,

/*
 * dyadic with optional subscript
 *	op2 op1 v (dyadic op)
 *	op2 op1 sub v+1 (subscripted dyadic op)
 */

	'?',	EXD,dsub,

/*
 * monadic or dyadic with optional subscript
 *	op2 op1 v (dyadic op)
 *	op1 v+1 (monadic op)
 *	op2 op1 sub v+2 (subscripted dyadic op)
 *	op1 sub v+3 (subscripted monadic op)
 */

	'OM'+B,	ROT,mdsub,
	',',	CAT,mdsub,

/*
 * end of list
 */

	0
};

int	comtab[]
{
	"clear",	comnam,		CLEAR,
	"debug",	comnull,	DEBUG,
	"digits",	comexpr,	DIGITS,
	"edit",		comnam,		EDIT,
	"erase",	comnam,		ERASE,
	"fns",		comnull,	FNS,
	"fuzz",		comexpr,	FUZZ,
	"load",		comnam,		LOAD,
	"origin",	comexpr,	ORIGIN,
	"vars",		comnam,		VARS,
	"width",	comexpr,	WIDTH,
	0,		unk
};
