#include "astro.h"

main(argc, argv)
char *argv[];
{
	register i, j;
	double d;

	pi = 3.1415926535897932;
	radian = pi/180.;
	radsec = radian/3600.;

	args(argc, argv);
	init();
	deld = PER/NPTS;

loop:
	d = day;
	pdate(d);
	if(flags & PRINT) {
		printf(" ");
		ptime(d);
	}
	printf("\n");
	for(i=0; i<=NPTS+1; i++) {
		setime(d);

		for(j=0; objlst[j]; j++) {
			(*objlst[j]->obj)();
			setobj(&objlst[j]->point[i]);
			if(flags & PRINT)
				output(objlst[j]->name, &objlst[j]->point[i]);
		}

		d =+ deld;
		if(flags & PRINT)
			exit();
	}
	search();
	day =+ PER;
	if(flags & CONTIN)
		goto loop;
}

args(argc, argv)
char *argv[];
{
	register char *p;
	int t[2];

	p = "";
	if(argc > 1)
		p = argv[1];
	while(*p)
	switch(*p++) {

	case 'd':
		flags =| DATE;
		continue;

	case 'l':
		flags =| LATUD;
		continue;

	case 'c':
		flags =| CONTIN;
		continue;

	case 'p':
		flags =| PRINT;
		continue;

	case 's':
		flags =| SPEAK;
		continue;

	case 'a':
		flags =| AZEL;
		continue;

	case 't':
		flags =| DELT;
		continue;

	case 'o':
		flags =| OCCULT;
		continue;

	case 'k':
		flags =| KITCH;
		continue;

	case '-':
		continue;

	default:
		printf("unknown option '%c'\n", p[-1]);
	}
	time(t);
	day = ltod(t)/86400. + 25567.5;
	if(flags & DATE)
		day = readate();

	awlong = (74. + 32./60.)*radian;
	nlat = (40. + 40./60.)*radian;
	elev = 0.;
	if(flags & LATUD)
		readlat();
}

double
readate()
{
	register i;
	int buf[259];
	double ifa[5];

	printf("year mo da hr min\n");
	for(i=0; i<259; i++)
		buf[i] = 0;
	rline(buf);
	for(i=0; i<5; i++)
		ifa[i] = atof(skip(i));
	return(convdate(ifa));
}

double
convdate(ifa)
double ifa[];
{
	double y, d;
	register i;

	y = ifa[0];
	i = ifa[1];
	d = ifa[2];
	while(i < 1) {
		i =+ 12;
		y =- 1.;
	}
	while(i > 12) {
		i =- 12;
		y =+ 1.;
	}
	if(y < 0.)
		y =+ 1.;
	y =+ 4712.;
	if(fmod(y, 4.) == 0 && i > 2)
		d =+ 1.;
	y = y*365. +
		floor((y+3.)/4.) +
		dmo[i-1] + d - 1.;
	if(y > 2361232.)
		y =- floor((y-1794167.)/36525.) -
			floor((y-1721117.)/146100.);
	y =+ ifa[3]/24. + ifa[4]/1440. - .5;
	return(y-2415020.);
}

readlat()
{
	register i;
	int buf[259];
	double ifa[3];

	for(i=0; i<259; i++)
		buf[i] = 0;
	printf("wlong nlat elev\n");
	rline(buf);
	for(i=0; i<3; i++)
		ifa[i] = atof(skip(i));
	awlong = ifa[0] * radian;
	nlat = ifa[1] * radian;
	elev = ifa[2];
}
