#include "astro.h"

int	timezone	5;
int	daylight	1;
char	*month[]
{
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December",
};

double
dsrc(d, ifa, i)
double d;
double ifa[];
{
	double y;

	do {
		ifa[i] =+ 1.;
		y = convdate(ifa);
		ddd(d, y, ifa, '>');
	} while(d >= y);
	do {
		ifa[i] =- 1.;
		y = convdate(ifa);
		ddd(d, y, ifa, '<');
	} while(d < y);
	return(d - y);
}

ddd(d, y, ifa, ch)
double d, y, ifa[];
{

}

dtsetup(d, ifa)
double d;
double ifa[];
{

	if(flags & KITCH) {
		d =- timezone/24.;
		bdtsetup(d, ifa);
		if(lastsun(ifa, 4))
			return;
		if(!lastsun(ifa, 10))
			return;
		d =+ 1./24.;
	}
	bdtsetup(d, ifa);
}

lastsun(ifa, m)
double ifa[];
{

	if(ifa[1] < m)
		return(1);
	if(ifa[1] > m)
		return(0);
	if(ifa[2] < 24)
		return(1);
	return(0); /* fix up later */
}

bdtsetup(d, ifa)
double ifa[];
double d;
{
	register i;
	double t;

	ifa[0] = floor(1900. + d/365.2425);
	ifa[1] = 1.;
	ifa[2] = 1.;
	ifa[3] = 0.;
	ifa[4] = 0.;
	ifa[1] = floor(1. + dsrc(d, ifa, 0)/30.);
	ifa[2] = floor(1. + dsrc(d, ifa, 1));
	dsrc(d, ifa, 2);

	d =- .5;
	t = (d - floor(d))*24.;
	ifa[3] = floor(t);
	ifa[4] = (t-ifa[3]) * 60.;
}

pdate(d)
double d;
{
	register i;
	double ifa[5];

	dtsetup(d, ifa);
	if(flags & SPEAK) {
		i = ifa[1];
		printf("%s ", month[i-1]);
		i = ifa[2];
		numb(i);
		printf("...");
		return;
	}
	printf("%.0f %.0f %.0f", ifa[0], ifa[1], ifa[2]);
}

ptime(d)
double d;
{
	register i;
	register char *s;
	double ifa[5];

	dtsetup(d, ifa);
	if(flags & SPEAK) {
		s = "AM";
		i = ifa[3];
		if(i >= 12) {
			s = "PM";
			i =- 12;
		}
		if(i == 0)
			i = 12;
		numb(i);
		i = ifa[4] + .5;
		if(i < 10) {
			if(i == 0) {
				printf("%s exactly ...", s);
				return;
			}
			printf("O ");
		}
		numb(i);
		printf("%s ...", s);
		return;
	}
	printf("%.0f:%.2f", ifa[3], ifa[4]);
}

char *unit[] {
	"zero",
	"one",
	"two",
	"three",
	"four",
	"five",
	"six",
	"seven",
	"eight",
	"nine",
	"ten",
	"eleven",
	"twelve",
	"thirteen",
	"fourteen",
	"fifteen",
	"sixteen",
	"seventeen",
	"eighteen",
	"nineteen"
};
char *decade[]{
	"twenty",
	"thirty",
	"forty",
	"fifty",
	"sixty",
	"seventy",
	"eighty",
	"ninety"
};

numb(n)
{

	if(n >= 100) {
		printf("%l ", n);
		return;
	}
	if(n >= 20) {
		printf("%s ", decade[n/10 - 2]);
		n =% 10;
		if(n == 0)
			return;
	}
	printf("%s ", unit[n]);
}
