#include "cx.h"

struct
{
	char	junk1[8];
	char	junk2;
	char	size0;
	int	size1;
	char	junk3[30];
} statb;
double	d;
double	de;
int	rwk, fwk;
int	rbk, fbk;
int	xpos, ypos, ptyp;
int	ibuf[259];
int	obuf[259];
int	shf;

main()
{
	register t;

	if(fopen("/mnt/chess/end/itab", ibuf) < 0) {
		printf("cannot open itab\n");
		exit();
	}
	pginit();
	obuf[0] = open("otab", 2);
	if(obuf[0] < 0) {
		printf("cannot open otab\n");
		exit();
	}
	seek(obuf[0], 0, 2);
	fstat(obuf[0], &statb);
	de = (statb.size0&0377)*65536. + statb.size1;
	if(statb.size1 < 0)
		de =+ 65536.;
	printf("seeking to %.0f\n", de);
	de =* 4.;
	d = 0.;
	amp = abuf;
	for(wkpos=0; wkpos<64; wkpos++) {
		rwk = rank[wkpos];
		fwk = file[wkpos];
		if(rwk >= 4 || fwk >= 4 || rwk > fwk)
			continue;
		board[wkpos] = wking;
	for(bkpos=0; bkpos<64; bkpos++) {
		rbk = rank[bkpos];
		fbk = file[bkpos];
		if(rwk == fwk && rbk > fbk)
			continue;
		if(abs(fwk-fbk) <= 1 && abs(rwk-rbk) <= 1)
			continue;
		board[bkpos] = bking;
	for(ptyp=0; ptyp<3; ptyp++)
	for(xpos=0; xpos<=64; xpos++)
	for(ypos=0; ypos<=64; ypos++) {
		t = getbit();
		if(d >= de) {
			if(t == 0) {
				t = place();
			}
			putbit(t);
		} else {
			shf++;
			if(shf == 8)
				shf = 0;
		}
		d =+ 1.;
	}
		board[bkpos] = 0;
	}
		board[wkpos] = 0;
	}
	for(t=0; t<8; t++)
		putbit(3);
	fflush(obuf);
}

place()
{
	register t;

	if(board[xpos] || board[ypos])
		*fault;
	if(xpos == ypos && xpos != 64)
		*fault;
	switch(ptyp) {

	case 0:
		wqpos = xpos;
		wrpos = ypos;
		brpos = 64;
		board[xpos] = wqueen;
		board[ypos] = wrook;
		break;

	case 1:
		if(ypos == 64)
			*fault;
		wqpos = xpos;
		wrpos = 64;
		brpos = ypos;
		board[xpos] = wqueen;
		board[ypos] = brook;
		break;

	case 2:
		if(xpos == 64 || ypos == 64)
			*fault;
		wqpos = 64;
		wrpos = xpos;
		brpos = ypos;
		board[xpos] = wrook;
		board[ypos] = brook;
	}
	board[64] = 0;
	t = eval();
	board[xpos] = 0;
	board[ypos] = 0;
	return(t);
}

eval()
{
	register *p1, *p3, l;
	int *p2, f;

	if(brpos != 64 && wrpos != 64)
		return(0);
	lmp = lbuf;
	p1 = lmp;
	wgen();
	p2 = lmp;
	if(p1 == p2)
		*fault;
	while(p1 != p2) {
		wmove(*p1++);
		if(!battack(wkpos)) {
			wremove();
			continue;
		}
		p3 = p2;
		lmp = p2;
		bgen();
		f = 1;
		while(p3 != lmp) {
			bmove(*p3++);
			if(!wattack(bkpos)) {
				bremove();
				continue;
			}
			l = lookup();
			bremove();
			if(l == 0)
				goto nw;
			f = 0;
		}
		if(f == 0) {
			wremove();
			return(1);
		}
	nw:
		wremove();
	}
	return(0);
}

int	iwrd;
getbit()
{
	register i;

	if(shf == 0)
		iwrd = getw(ibuf);
	i = (iwrd>>14) & 03;
	iwrd =<< 2;
	return(i);
}

int	owrd;
int	nwrd;
putbit(b)
{
	extern errno;

	owrd = (owrd<<2) | b;
	shf++;
	if(shf == 8) {
		putw(owrd, obuf);
		if(errno)
			abort();
		shf = 0;
	}
}

#define	NBUF	40
int	nbuf;
int	fdes;
struct	buf
{
	int	bno;
	char	abuf[512];
} buf[NBUF];
struct	buf	*pgtab[3000];

pginit()
{
	register i;

	fdes = open("/mnt/chess/end/itab", 0);
	seek(fdes, 3000, 3);
	for(i=0; i<NBUF; i++) {
		pgtab[i] = &buf[i];
		buf[i].bno = i;
		read(fdes, buf[i].abuf, 512);
	}
}

double	ind;

lookup()
{
	register k, b, o;
	double index();

	ind = index();
	if(ind < 0.)
		return(3);
	k = ind/4096.;
	if(pgtab[k] == 0) {
		o = &buf[nbuf];
		nbuf++;
		if(nbuf >= NBUF)
			nbuf = 0;
		pgtab[o->bno] = 0;
		o->bno = k;
		seek(fdes, k+3000, 3);
		if(read(fdes, o->abuf, 512) != 512)
			*fault;
		pgtab[k] = o;
	}
	o = ind - k*4096.;
	b = o&07;
	o =>> 3;
	if(o < 0 || o >= 512)
		*fault;
	k = pgtab[k]->abuf[o];
	if((k<<b) & 0200)
		return(1);
	return(0);
}
