/ read from stand input
/ used for dictionaries
/ list from 'list'

.globl	getc, mesg

	sys	open; flist; 0
	bec	1f
	jsr	r5,mesg
		<cannot open 'list'\n\0>; .even
	sys	exit
1:
	mov	r0,-(sp)
	sys	read; list; 1000.
	mov	$list,r0
	mov	r0,r1
1:
	mov	r1,r2
2:
	movb	(r0)+,(r2)
	beq	1f
	cmpb	(r2)+,$'\n
	bne	2b
	add	$8,r1
	dec	r2
	cmp	r1,r2
	beq	1b
	jsr	r5,mesg
		<bad 'list' file\n\0>; .even
	br	1b
1:
	mov	(sp)+,r0
	sys	close
	jsr	pc,setup
1:
	mov	$ascii,r0
1:
	clr	(r0)+
	cmp	r0,$ascii+128.
	blo	1b
	mov	$list,r0
1:
	movb	(r0),r1
	beq	1f
	incb	ascii(r1)
	add	$8.,r0
	br	1b
1:
	mov	$inword,r1
2:
	jsr	r5,getc; iobuf
	bcs	1f
	tst	r0
	ble	1f
	cmp	r0,$'-
	beq	2b
	cmp	r0,$'\n
	beq	2f
	cmp	r0,$'A
	blo	9f
	cmp	r0,$'Z
	bhi	9f
	add	$'a-'A,r0
9:
	movb	r0,(r1)+
	br	2b
2:
	clrb	-(r1)
	jsr	pc,crypt
	br	1b
1:
	sys	exit

flist:	<list\0>; .even
bel:	7
space:	< >
newline: <\n>
.even

.bss
inword:	.=.+20
word:	.=.+20
ascii:	.=.+128.
.text
/ crypt -- password incoding

/	mov	$key,r0
/	jsr	pc,crypt

.globl	crypt, word

/
/
/	establish wheel codes and cage codes
/
setup:
	mov	$wheelcode,r4
	mov	$cagecode,r5
	mov	$256.,-(sp)
2:
	clr	r2
	clr	(r4)
	mov	$wheeldiv,r3
3:
	clr	r0
	mov	(sp),r1
	div	(r3)+,r0
	add	r1,r2
	bic	$40,r2
	bis	shift(r2),(r4)
	cmp	r3,$wheeldiv+6.
	bhis	4f
	bis	shift+4(r2),(r5)
4:
	cmp	r3,$wheeldiv+10.
	blo	3b
	sub	$2,(sp)
	tst	(r4)+
	tst	(r5)+
	cmp	r4,$wheelcode+256.
	blo	2b
	tst	(sp)+
	rts	pc

/
	.data
shift:	1;2;4;10;20;40;100;200;400;1000;2000;4000;10000;20000;40000;100000
	1;2
wheeldiv: 32.; 18.; 10.; 6.; 4.
	.bss
cagecode: .=.+256.
wheelcode: .=.+256.
	.text
/
crypt:

	mov	$inword,r1
	mov	$key,r0
	movb	$004,(r0)+
	movb	$034,(r0)+
1:
	movb	(r1)+,(r0)+
	bne	1b
1:
	dec	r0
/
/
/	fill out key space with clever junk
/	simultaneously set the lugs on the cage bars
/
	mov	$key,r1
	mov	$cage,r4
	mov	$128.+8.,r5
1:
	movb	-1(r0),r2
	movb	(r1)+,r3
	xor	r3,r2
	movb	r2,(r0)+
	asl	r3
	mov	cagecode(r3),(r4)+
	sob	r5,1b
/
/	now spin the cage against the wheel to produce output.
/
	mov	$word,r4
	mov	$key+64.,r3
3:
	movb	-(r3),r2
	asl	r2
	mov	wheelcode(r2),r2
	mov	$cage,r0
	clr	r5
	mov	$128.,r1
1:
	bit	r2,(r0)+
	beq	2f
	incb	r5
2:
	sob	r1,1b
/
/	we have a piece of output from current wheel
/	it needs to be folded to remove lingering hopes of
/	inverting the function
/
	movb	fold(r5),r5
	movb	r5,(r4)+
	jsr	pc,nxtchr
		rts pc
	br	3b

nxtchr:
	cmp	r4,$word+1
	bhi	1f
	tstb	ascii(r5)
	beq	2f
	add	$2,(sp)
2:
	rts	pc
1:
	mov	r0,-(sp)
	mov	r1,-(sp)
	mov	$list,r0
1:
	mov	r0,r1
	mov	$word,r5
2:
	cmpb	(r1)+,(r5)+
	bne	2f
	cmp	r5,r4
	blo	2b
	cmp	r4,$word+8
	bhis	3f
	mov	(sp)+,r1
	mov	(sp)+,r0
	add	$2,(sp)
	rts	pc
3:
	mov	$1,r0
	sys	write; word; 8
	mov	$1,r0
	sys	write; space; 1
	mov	$-1,0f
	mov	$inword,r0
9:
	inc	0f
	tstb	(r0)+
	bne	9b
	mov	$1,r0
	sys	write; inword; 0:..
	mov	$1,r0
	sys	write; newline; 1
	br	1f
2:
	add	$8,r0
	tstb	(r0)
	bne	1b
1:
	mov	(sp)+,r1
	mov	(sp)+,r0
	rts	pc

fold:
.byte	'0, '1, '2, '3, '4, '5, '6, '7
.byte	'8, '9, 'A, 'B, 'C, 'D, 'E, 'F
.byte	'G, 'H, 'I, 'J, 'K, 'L, 'M, 'N
.byte	'O, 'P, 'Q, 'R, 'S, 'T, 'U, 'V
.byte	'W, 'X, 'Y, 'Z, 'a, 'b, 'c, 'd
.byte	'e, 'f, 'g, 'h, 'i, 'j, 'k, 'l
.byte	'm, 'n, 'o, 'p, 'q, 'r, 's, 't
.byte	'u, 'v, 'w, 'x, 'y, 'z
.byte	'0, '1, '2, '3, '4, '5, '6, '7
.byte	'8, '9, 'A, 'B, 'C, 'D, 'E, 'F
.byte	'G, 'H, 'I, 'J, 'K, 'L, 'M, 'N
.byte	'O, 'P, 'Q, 'R, 'S, 'T, 'U, 'V
.byte	'W, 'X, 'Y, 'Z, 'a, 'b, 'c, 'd
.byte	'e, 'f, 'g, 'h, 'i, 'j, 'k, 'l
.byte	'm, 'n, 'o, 'p, 'q, 'r, 's, 't
.byte	'u, 'v, 'w, 'x, 'y, 'z
.byte	'0, '1, '2, '3, '4, '5, '6, '7
.byte	'8, '9, 'A, 'B, 'C, 'D, 'E, 'F
.byte	'G, 'H, 'I, 'J, 'K, 'L, 'M, 'N
.byte	'O, 'P, 'Q, 'R, 'S, 'T, 'U, 'V
.byte	'W, 'X, 'Y, 'Z, 'a, 'b, 'c, 'd
.byte	'e, 'f, 'g, 'h, 'i, 'j, 'k, 'l
.byte	'm, 'n, 'o, 'p, 'q, 'r, 's, 't
.byte	'u, 'v, 'w, 'x, 'y, 'z, '0, '1

	.bss
key:	.=.+128.+100.
cage:	.=.+256.
wheel:	.=.+256.
iobuf:	.=.+520.
list:	.=.+1000.
