#include "cx.h"
/*
 *	It is not a move, even the
 *	best move, that you must seek,
 *	but a realizable plan.
 */

int	gopen();
int	gwhite();
int	gblack();
int	gevent();
int	cbook();
int	odds();
int	copen();
int	eh();
int	csrch();
int	feach();
int	input();
int	manual();
int	cnice();
int	cpict();
int	cplot();
int	cplay();
int	chint();
int	crem();
int	cprint();
int	scale();
int	cgame();
int	cposit();
int	cscore();
int	cselec();
int	setup();
int	quick();
int	force();
int	depth();
int	find();
int	slow();
int	noquick();
int	cmate();
int	cpuzz();
int	cthreat();
int	cmove();
int	cform();
int	prime();
int	unix();
int	exit();
int	prval();
int	comnt();
int	cindex();
int	cend();
struct {
	char	*command;
	int	(*funct)();
} comlist[]
{
	"opening:",	&gopen,
	"white:",	&gwhite,
	"black:",	&gblack,
	"event:",	&gevent,
	"book",		&cbook,
	"odds",		&odds,
	"open",		&copen,
	"eh",		&eh,
	"search",	&csrch,
	"foreach",	&feach,
	"input",	&input,
	"manual",	&manual,
	"nice",		&cnice,
	"pict",		&cpict,
	"plot",		&cplot,
	"play",		&cplay,
	"hint",		&chint,
	"remove",	&crem,
	"print",	&cprint,
	"scale",	&scale,
	"game",		&cgame,
	"posit",	&cposit,
	"score",	&cscore,
	"seek",		&cselec,
	"setup",	&setup,
	"quick",	&quick,
	"force",	&force,
	"depth",	&depth,
	"find",		&find,
	"slow",		&slow,
	"noquick",	&noquick,
	"mate",		&cmate,
	"puzz",		&cpuzz,
	"threat",	&cthreat,
	"moves",	&cmove,
	"format",	&cform,
	"prime",	&prime,
	"!",		&unix,
	"exit",		&exit,
	"value",	&prval,
	"index",	&cindex,
	"end",		&cend,
	"/",		&comnt,
	0,
};

main(argc, argv)
char *argv[];
{
	register a, b;

	obuf[0] = 1;
	istk[0] = 0;
	ostk[0] = 1;
	lmp = lbuf;
	amp = abuf;
	pvp = pvbuf;
	if(argc > 1)
		bookf = open(argv[1], 0); else
		bookf = open("/usr/lib/book", 0);
	if(bookf >= 0)
		read(bookf, &bookp, 2);
	manmove = 1;		/* moving for white */
	state = 2;		/* manual */

loop:
	fflush(obuf);
	if(fbuf[0]) {
		sbufp = fbuf;
		for(a=0; comlist[a].command; a++)
		if(match(comlist[a].command)) {
			(*comlist[a].funct)();
			break;
		}
	}
	if(state < 0) {
		manmove = mantom;
		state++;
	}
	if(manmove == mantom && state <= 0) {
		a = amp;
		play();
		b = amp;
		if(a == b)
			state = 2;
		goto loop;
	}
	do
		rline();
	while(sbuf[0] == '\0');
	for(a=0; comlist[a].command; a++)
	if(match(comlist[a].command)) {
		(*comlist[a].funct)();
		goto loop;
	}
	switch(format? stdin(): algin()) {

	case 1:
		printf("eh?\n");
		goto er;

	case 2:
		printf("ambiguous\n");
		goto er;

	case 3:
		printf("illegal\n");

	er:
		if(icount)
			printf("%s\n", sbuf);
		while(icount)
			ipop();
		seek(istk[0], 0, 2);
		goto loop;
	}
	gmove(abmove);
	goto loop;
}

gopen()
{
}

gwhite()
{

	getcomnt(comwbuf);
}

unix()
{

	if(*sbufp)
		execl("/bin/sh", "sh", "-c", sbufp, 0); else
		execl("/bin/sh", "sh", 0);
}

comnt()
{

	printf("%s\n", sbufp);
}

getcomnt(b)
char *b;
{
	register char *p1, *p2;

	p1 = b;
	p2 = sbufp;
	while(*p1++ = *p2++);
}

gblack()
{

	getcomnt(combbuf);
}

gevent()
{

	getcomnt(comebuf);
}

cbook()
{
	register a;

	a = number(1);
	if(a)
		book(a, 0); else
		bookp = 0;
	newline();
}

copen()
{
	char buf[40];

	if(opening) {
		seek(bookf, opening, 0);
		read(bookf, buf, 40);
		printf("%s\n", buf);
	}
}

eh()
{
	score(number(1));
}

input()
{
	register a;

	if(filename()) {
		a = open(sbuf, 0);
		if(a < 0) {
			printf("Cannot open %s\n", sbuf);
		} else {
			ipush(a);
			state = 2;
		}
	}
}

manual()
{
	state = 2;
}

cnice()
{
	nice(number(16));
}

cprint()
{
	print(0);
}

cpict()
{
	print(1);
}

cplot()
{

	print(2);
}

chint()
{
	register *p;

	p = amp;
	play();
	prime();
	while(p != amp)
		gremove();
}

cplay()
{
	state = -number(1);
	if(state == 0)
		state = 2;
}

scale()
{
	vts = number(1);
	vtx = 0;
	vty = 0;
}

cposit()
{

	posit(0);
}

cgame()
{
	register a, *p;
	int m;

	a = outfil();
	p = amp;
	while(amp > abuf)
		gremove();
	while(amp < p) {
		m.pfrm = amp->mfrm;
		m.pto = amp->mto;
		gmove(m);
		posit(m);
	}
	if(a)
		opop();
}

cscore()
{
	register a;

	a = outfil();
	if(opening) {
		printf("opening: ");
		copen();
	}
	if(comwbuf[0])
		printf("white:%s\n", comwbuf);
	if(combbuf[0])
		printf("black:%s\n", combbuf);
	if(comebuf[0])
		printf("event:%s\n", comebuf);
	score(1000);
	if(a)
		opop();
}

feach()
{
	register char *p1, *p2;

	p1 = sbufp;
	while(*p1 == ' ')
		p1++;
	p2 = fbuf;
	while(*p2++ = *p1++);
}

crem()
{
	register n;

	n = number(1);
	while(amp > abuf && n--)
		gremove();
	state = 2;
}

csrch()
{
	register i;
	char b[64];

	for(i=0; i<64; i++)
		b[i] = board[i];
	while(amp != abuf)
		gremove();
	src1(b);
	newline();
}

src1(b)
char *b;
{
	register o;
	int mb[3];

	o = bcmpr(b);
	if(o == 0) {
		score(1000);
		newline();
		return;
	}
	if(o < 0 || bookp == 0)
		return;
	o = bookp;
loop:
	seek(bookf, o, 0);
	o =+ 4;
	read(bookf, mb, 6);
	if(mb[0] >= 0) {
		gmove(mb[0]);
		src1(b);
		gremove();
		if(mb[2] >= 0)
			goto loop;
	}
}

bcmpr(b)
char *b;
{
	register i, p, r;
	char pcs[33];

	for(i=0; i<33; i++)
		pcs[i] = 0;
	for(i=0; i<64; i++)
		pcs[board[i]]++;
	r = 0;
	for(i=0; i<64; i++) {
		p = b[i];
		if(p != board[i]) {
			r++;
			if(pcs[p] == 0)
				return(-1);
		}
	}
	return(r);
}

cmove()
{
	register *p1, *p2;

	p1 = agen();
	p2 = p1;
	while(p2 != lmp)
		out(*p2++);
	lmp = p1;
}

cmate()
{

	if(mate(number(4)))
		prime();
	newline();
}

cpuzz()
{

	pmate(number(2), 1);
	newline();
}

cform()
{

	format = !format;
}

cselec()
{

	selec();
	state = 2;
}

cthreat()
{
	register *p1, *p2;
	int n, f;

	n = number(2);
	p1 = agen();
	p2 = p1;
	while(p2 != lmp) {
		move(*p2++);
		if(check()) {
			remove();
			continue;
		}
		move(NULLM);
		f = qmate(n);
		remove();
		if(f) {
			score(1);
			fflush(obuf);
		}
		remove();
	}
	lmp = p1;
	newline();
}

prval()
{
	register char *p;

	score(1);
	for(p = &value; p < (&value)+1; p++)
		printf("	%d", *p);
	newline();
}
